// *****************************************************************
//  
// AS-kit
//  : 15.04.2019
// *****************************************************************

#ifndef ADC_H
#define ADC_H

#include "Kernel.h"
#include "ADC.h"

void ADC_Init(unsigned char channel, ADC_PRESCALER prescaler)
{
	ADCSRA = 0x00; // ADC
	ADMUX  = channel | (ADMUX & (1<<REFS1 | 1<<REFS0));
	ADCSRA = 0b11000000 | prescaler; //  ADC,   
	ADC_GetValue();
}

unsigned int ADC_GetValue(void)
{
	unsigned int result = 0;
	ADCSRA |= (1<<ADIF);  //    
	asm("nop");
	ADCSRA |= (1<<ADIF);  //    
	ADCSRA &= ~(1<<ADIE); //  
	ADCSRA |= (1<<ADSC);  //  
	while (!(ADCSRA&(1<<ADIF))); //   
	result = ADC;
	return result; //   
}

#endif