// *****************************************************************
// Kernel.c,  
// AS-kit
//  : 15.04.2019
// *****************************************************************
#include <avr/io.h>

#ifndef KERNEL_H
#define KERNEL_H

extern unsigned char HEX[16];

typedef enum
{
	false = 0,
	true = 1
} bool;

typedef unsigned char byte;
typedef unsigned int word;
typedef unsigned long dword;

// 
void Delay(unsigned int ms);

//  USART
#define USART0_ENABLE
#define USART1_ENABLE

// 
#define LCD_ASMEGA_M
#define LCD_LINES 2
#define LCD_COLUMNS 20
#define LCD_PATTERN_HEIGHT 7

//  
#define LED_PORT	PORTD
#define LED_DDR		DDRD
#define	LED1		_BV(6)
#define LED2		_BV(7)

// 
#define DAC_ASMEGA_M

// ---------   --------
typedef enum
{
    ADC_AREF = 0,
    ADC_VREF = 1,
    ADC_INTREF = 2
} ADC_REF;

typedef enum
{
    DAC_OFF = 0,
    DAC_VOLTAGE	= 1,
    DAC_SAW	= 2,
    DAC_TRIANGLE = 3,
    DAC_MEANDRE = 4
} DAC_MODE;

//   
#define CMD_PING    '?'
#define CMD_EXIT    'Q'

// 
#define CMD_LED     'L'
#define LED1_ON     '0'
#define LED1_OFF    '1'
#define LED2_ON     '2'
#define LED2_OFF    '3'

// 
#define CMD_PORTS       'P'
#define CMD_PORT_READ   'R'
#define CMD_PORT_WRITE  'W'

// 
#define CMD_ADC         'A'
#define CMD_ADC_READ    'R'
#define CMD_ADC_SETREF  'F'

// 
#define CMD_DAC         'V'

// 
#define CMD_LCD     'D'

// 
#define CMD_XTAL    'X'

// 
#define CMD_TIME    'T'

#endif