// *****************************************************************
// LCD driver. Header file
// AS-kit
// Last updated: 15.04.2019
// *****************************************************************
#ifndef LCD_H
#define LCD_H

typedef enum
{
  CURSOR_OFF = 0,
  CURSOR_ON = 1,
  CURSOR_STATIC = 2
} LCD_CURSOR_STATE;

extern byte LCD_X, LCD_Y;

void LCD_Init(void);

void LCD_ClearBuf(void);

void LCD_SetBlink(void);
void LCD_SetNoBlink(void);
void LCD_SetBlinkTo(bool Blink);

void LCD_SetPos(byte X, byte Y);
void LCD_SetCursorState(LCD_CURSOR_STATE CursorState);

void LCD_Refresh(void);
void LCD_OnIdle(word Ticks); // 128 times per second, auto blink

void LCD_WriteChar(byte Char);

void LCD_WriteByteHex(byte c);
void LCD_WriteWordHex(word c);
void LCD_WriteDwordHex(dword c);

void LCD_WriteByteBinary(byte c);
void LCD_WriteWordBinary(word c);
void LCD_WriteDwordBinary(dword c);

void LCD_WriteString(char* String);
void LCD_WriteBuffer(byte* String, byte Length);
void LCD_WriteInt(word Number);
void LCD_WriteSignedInt(int Number);
void LCD_WriteLong(dword Number);
void LCD_WriteInt00(byte Number);

void LCD_WriteTimeMMSS(dword Second);
void LCD_WriteTimeHHMM(dword Second);
void LCD_WriteTimeHHMMSS(dword Second);

void LCD_ScrollUp(void);
void LCD_WriteConsole(char* String);
void LCD_WriteCharConsole(byte Char);

void LCD_ModifyCharacter(byte *data, byte address);

void LCD_StartBlink(void);
void LCD_RestartBlink(void);

#endif

